//------------------------------------------------------------------------------
// Author: theSplit for phre4k [TEST]
//------------------------------------------------------------------------------
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

#define SDL_MAIN_HANDLED
#include <SDL2/SDL.h>
#include <SDL2/SDL_audio.h>

//------------------------------------------------------------------------------

// Switches
#define BUFFERTIMEOUT 5000
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Main routine
int main(int argc, char *argv[]) {
  short int timeout = BUFFERTIMEOUT;

  for (int i = 0; i < argc; ++i) {
    if (strncmp(argv[i], "-t", 2) == 0) timeout = atoi(&argv[i][2]);
  }

  if (timeout == 0) timeout = BUFFERTIMEOUT;

  printf("%d\n", timeout);

  SDL_SetMainReady();
  if (SDL_Init(SDL_INIT_AUDIO) != 0) {
    printf("Error initializing audio: %s\n", SDL_GetError());
    SDL_Quit();
    return 1;
  }

  SDL_AudioSpec want, have;
  SDL_AudioDeviceID dev;

  SDL_memset(&want, 0, sizeof(want));
  want.freq = 48000;
  want.format = AUDIO_F32;
  want.channels = 2;
  want.samples = 4096;
  want.callback = NULL;

  int byteBuffer = 512;
  int soundBuffer[byteBuffer];
  memset(soundBuffer, 0, byteBuffer);

  dev = SDL_OpenAudioDevice(NULL, 0, &want, &have, SDL_AUDIO_ALLOW_FORMAT_CHANGE);
  if (dev == 0) {
      SDL_Log("Failed to open audio: %s\n", SDL_GetError());
      SDL_Quit();
      return 1;
  }

  while (true) {
    SDL_QueueAudio(dev, soundBuffer, byteBuffer);
    SDL_PauseAudioDevice(dev, 0);
    SDL_Delay(timeout);
  }

  SDL_CloseAudioDevice(dev);
  SDL_Quit();
  return 0;
}
